/*
						+--------------------------------+
                        |                                |
                        |     *** TX2 Compiller ***      |
                        |                                |
                        |        L. Polok  2002         |
                        |                                |
                        |          FileList.cpp          |
                        |                                |
						+--------------------------------+
*/

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "FileList.h"

CFileList::~CFileList()
{
	if(file != NULL)
		free((void*)file);
	file_num = 0;
	// free memory
}

int CFileList::AddFile(char *file_name, int tag)
{
	if(file_num == 0) {
		file = (FILE_NAME*) malloc(0);
		// prealloc array (necessary for realloc)
	}

	file_num ++;
	if((file = (FILE_NAME*) realloc(file,
	   file_num * sizeof(FILE_NAME))) == NULL)
		return -1;
	// enlarge memory amount

	file[file_num - 1].tag = tag;
	strcpy(file[file_num - 1].name, file_name);
	// copy data

	return file_num - 1;
	// return index of current file in array
}

FILE_NAME *CFileList::File(int n_index)
{
	if(n_index < file_num)
		return &file[n_index];
	// returns name of file
	return NULL;
}

void CFileList::Erase()
{
	if(file_num) {
		file_num = 0;
		free((void*)file);
	}
	// erase current list
}

int CFileList::Load(char *file_name)
{
	char ln[256];
	char fn[256];
	FILE *fr;
	int i, t;
	
	this->Erase();
	// erase current list

	if((fr = fopen(file_name, "r")) == NULL)
		return 0;
	// open file

	if(!fgets(ln, 255, fr)) {
		fclose(fr);
		return 0;
	}
	// reads number of files

	for(i = atoi(ln); i > 0; i --) {
		if(!fgets(ln, 255, fr)) {
			i ++;
			continue;
		}
		// read line of text
		sscanf(ln, "%s %d", fn, &t);
		this->AddFile(fn, t);
		// adds file to list
	}
	// reading filelist

	fclose(fr);
	// close file

	return 1;
}





