/*
						+--------------------------------+
                        |                                |
                        |     *** TX2 Compiller ***      |
                        |                                |
                        |        L. Polok  2002         |
                        |                                |
                        |           IntTable.h           |
                        |                                |
						+--------------------------------+
*/


#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "IntTable.h"

CIntTable::~CIntTable()
{
	if(val != NULL)
		free((void*)val);
	val_num = 0;
	// free unused memory
}

unsigned __int32 CIntTable::Val(int n_index)
{
	if(n_index < val_num)
		return val[n_index];
	// returns value on index
	return 0;
}

int CIntTable::Find(unsigned __int32 value)
{
	int i, a;

	if(!val_num)
		return -1;
	// nothing to search in

	for(i = 0; i < val_num; i ++)
		if(val[i] == value)
			return i;
	return -1;

	if(val[val_num - 1] < value)
		return -1;
	if(val[0] > value)
		return -1;
	// cannot be found

	a = 0;
	i = val_num;

	while(1) {
		if(val[a] == value)
			return a;
		// record found

		if(a < val_num - 1) {
			if(val[a] < value && val[a + 1] > value)
				return -1;
		}
		if(a > 0) {
			if(val[a - 1] < value && val[a] > value)
				return -1;
		}
		// cannot be found

		if(val[a] < value) {
			a += i;
			if(a >= val_num)
				a = val_num - 1;
		} else {
			a -= i;
			if(a < 0)
				a = 0;
		}
		// move pointer

		i = ((i >> 1) == 0) ? 1 : (i >> 1);
		// halve interval, but never zero
	}
	// fast binary search
}

int CIntTable::FindPrev(unsigned __int32 value)
{
	int i, a;

	if(!val_num)
		return -1;
	// nothing to search in

	if(val[0] >= value)
		return -1;
	if(val_num == 1)
		return -1;
	// haven't prev value (xtreme case)

	if(val[val_num - 1] < value)
		return val_num - 1;
	// lastval

	a = 0;
	i = val_num;

	while(1) {
		if(a > -1) {
			if(val[a] < value && val[a + 1] >= value)
				return a;
		}
		// record found

		if(val[a] < value) {
			a += i;
			if(a >= val_num)
				a = val_num - 1;
		} else {
			a -= i;
			if(a < 0)
				a = 0;
		}
		// move pointer

		i = ((i >> 1) == 0) ? 1 : (i >> 1);
		// halve interval, but never zero
	}
	// fast binary search
}

int CIntTable::FindNext(unsigned __int32 value)
{
	int i, a;

	if(!val_num)
		return -1;
	// nothing to search in

	if(val[val_num - 1] <= value)
		return -1;
	if(val_num == 1)
		return -1;
	// haven't next value (xtreme case)

	a = 0;
	i = val_num;

	while(1) {
		if(a > 0) {
			if(val[a - 1] <= value && val[a] > value)
				return a;
		}
		// record found

		if(val[a] < value) {
			a += i;
			if(a >= val_num)
				a = val_num - 1;
		} else {
			a -= i;
			if(a < 0)
				a = 0;
		}
		// move pointer

		i = ((i >> 1) == 0) ? 1 : (i >> 1);
		// halve interval, but never zero
	}
	// fast binary search
}

int CIntTable::Add(unsigned __int32 value)
{
	int i, j;

	if(val_num == 0) {
		if((val = (unsigned __int32*) malloc(4)) == NULL)
			return -1;
		// lock memory
		val[0] = value;
		val_num = 1;
		// copy data
		return 0;
		// first record
	}

	i = this->FindPrev(value);

	i ++;
	if(i < val_num) {
		if(val[i] == value)
			return i;
	}
	// found
	
	// find previous record (if haven't then place it as first)
	if((val = (unsigned __int32*) realloc
	   (val, val_num * 4 + 4)) == NULL)
		return -1;
	// realloc memory
	for(j = val_num; j > i; j --)
		val[j] = val[j - 1];
	// push data
	val[i] = value;
	val_num ++;
	// copy data

	return i;
}