/*
						+--------------------------------+
                        |                                |
                        |     *** TX2 Compiller ***      |
                        |                                |
                        |        L. Polok  2002         |
                        |                                |
                        |          ImgLoader.h           |
                        |                                |
						+--------------------------------+
*/

#define IT_UNKNOWN -1
#define IT_BITMAP   0
#define IT_PCX      1
#define IT_GIF      2

#define	BI_RGB	0L
#define	BI_RLE8	1L
#define	BI_RLE4	2L

typedef struct {
    unsigned char   Id;
    unsigned char   Version;
    unsigned char   Format;
    unsigned char   BitsPixelPlane;
    unsigned short  Xmin;
    unsigned short  Ymin;
    unsigned short  Xmax;
    unsigned short  Ymax;
    unsigned short  Hdpi;
    unsigned short  Vdpi;
    unsigned char   EgaPalette[48];
    unsigned char   Reserved;
    unsigned char   NumberOfPlanes;
    unsigned short  BytesLinePlane;
    unsigned short  PaletteInfo;
    unsigned short  HScreenSize;
    unsigned short  VScreenSize;
    unsigned char   Filler[54];
} PCXHEADER;

typedef struct {
    unsigned char VgaPalette[768];
} PCXVGAPALETTE;

typedef struct {
	unsigned __int32 *bytes;
	int Width, Height;
} BMP;

class CImgLoader
{
public :
	BMP *Load_BMP(char *filename);
	BMP *Load_PCX(char *filename);
	BMP *Load_GIF(char *filename);
	BMP	*Load_TrueColor_BMP(char *filename);
	//
	int	Save_TrueColor_BMP(char *filename, BMP *bmp);
	//
	CImgLoader();
	virtual ~CImgLoader();
	//
	int DetectImg_Type(char *filename);
private:
	// variables
	//
	unsigned __int32 paleta[256];
	unsigned __int32 *bytes;
	//int Width, Height;
	//

	// functions
	//
	int	Read256ColorBMP_RGB(BITMAPINFOHEADER
		*bmihInfoHlBMP, FILE *BMPfp);
	int	Read256ColorBMP_RLE8(BITMAPINFOHEADER
		*bmihInfoHlBMP, FILE *BMPfp);
	//
	void ReadPcxHeader(PCXHEADER *PcxHead, FILE *FpPcx);
	short PcxDecodeScanLine(unsigned char *DecodedBuffer,
		int BufferSize, FILE *FpPcx);
	//
};